#! /usr/bin/perl
# Copyright (C) 2001  Jos van den Oever <Jos.vandenOever@FenK.wau.nl> , Jan van Haarst <jan@vanhaarst.net>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

# doall.pl
# 	zet deze in je crontab om ieder uur op iedere host hostlisting te draaien
# hostlisting.pl
# 	kijkt of de file die overeenkomt met de ip geupdate moet worden en doet dit zonodig
# isup
# 	cgi-bin die icoontje up of down stuurt afhankelijk van of de host up of down is
# findsmb
# 	simpel gezegd: de databasetextfiles greppen en formatteren (cgi-bin)

#! /usr/bin/perl -W

use strict;

# Set the time of start.
my $starttime = time;

# remove files older than two days
`find . -daystart -mmin +2880 -name '137*' -exec rm \\\{\\\} \\\;`;

# scan the net for hosts that are up and sharing
my $i;
for ($i=220; $i<243; $i++) {
	my @lines = `nmap -PT21 -p21 -T5 137.224.$i.11-250`;
	my $ip;
	foreach (@lines) {
		if (m/\d\d?\d?\.\d\d?\d?\.(\d\d?\d?)\.(\d\d?\d?)/) {
			$ip = "137.224.$1.$2";
		} elsif (m/^21/) {
			`/var/www/crawler/ftplist/ftplist $ip > $ip`;
		}
	}
}
# write number of non-zero files to file 'computers'
`f=(\$(find . -size +0c -ls |wc)); echo \$f>computers`;
# write number of lines in files to file 'files'
`f=(\$(wc 137.224.2*|tail -1)); echo \$f>files`;
# write number of files for a few extensions
my @extensions=("mp3","ogg","avi");
foreach (@extensions) {
	`f=(\$(grep -i '.$_\$' 137.224.2*|wc)); echo \$f>$_`;
}

# write the time it takes to crawl to a file for.
my $processtime;
$processtime = time - $starttime;
open(FH,">> crawltime");
print FH time."\t".$processtime."\t"."\n";
close(FH);

