#! /usr/bin/perl
use strict;

my %names;
my %groups;
my $i;
for ($i=220; $i<243; $i++) {
foreach (`nmap -sP 137.224.$i.11-250`) {
	if (m/\d\d?\d?\.\d\d?\d?\.(\d\d?\d?)\.(\d\d?\d?)/) {
                my $ip = "137.224.$1.$2";

		# get the name of the host
		my @lines1 = `nmblookup -A $ip`;
		my $name;
		my $group;
		foreach (@lines1) {
		        if (m/^[\t ]+([^\t]+[^ \t])[ \t]+<00> - <GROUP>/) {
		                $group = $1;
		        } elsif (m/^[\t ]+([^\t]+[^ \t])[ \t]+<00> - /) {
		                $name = $1;
			}
		}
		chomp $group;
		$names{$ip} = $name;
		$groups{$ip} = $group;
	}
}
}

my @oldnames = `cat computernames`;
foreach (@oldnames) {
	chomp;
	my ($ip, $name, $group) = split("\t");
	if (!$names{$ip}) {
		$names{$ip} = $name;
	}
	if (!$groups{$ip}) {
		$groups{$ip} = $name;
	}
}
open(FH, "> computernames");
foreach (keys(%names)) {
	print FH $_."\t".$names{$_}."\t".$groups{$_}."\n";
}
close(FH);
