#include "urllist.h" 

URLList::URLList(int maxtime) {

	connect( &op, SIGNAL( newChildren( const QValueList<QUrlInfo> &, QNetworkOperation * ) ),
        		this, SLOT( slotInsertEntries( const QValueList<QUrlInfo> &, QNetworkOperation * ) ) );
	connect( &op, SIGNAL( start( QNetworkOperation * ) ),
		this, SLOT( slotStart( QNetworkOperation *) ) );
	connect( &op, SIGNAL( finished( QNetworkOperation * ) ),
		this, SLOT( slotFinished( QNetworkOperation *) ) );
	queue.setAutoDelete(true);
	this->maxtime = maxtime;
	timer = new QTimer(this);
	connect(timer, SIGNAL(timeout()), this, SLOT(timeout()));
}
URLList::~URLList() {
}
void
URLList::writeList(const QString &ip) {

	current = "ftp://" + ip;
	op = current;
	if (!op.isValid()) {
		cerr << current << " is not a valid url." << endl;
		return;
	}
	op.setPort(21);
	current = "";
	op.setPath(current);
	connected = false;
	timer->start(maxtime, TRUE);
	op.listChildren();
}

void
URLList::slotInsertEntries(const QValueList<QUrlInfo> &info, QNetworkOperation *qno) {
	QValueList<QUrlInfo>::ConstIterator it = info.begin();
	for ( ; it != info.end(); ++it ) {
		const QUrlInfo &inf = *it;
		if (inf.isReadable() && inf.name() != "."
				&& inf.name() != "..") {
			if (inf.isDir() && !inf.isSymLink()) {
				queue.enqueue(new QString(current+"/"+inf.name()));
			} else {
				cout << current<<"/"<<inf.name() << endl;
			}
		} else {
		}
	}
}
void
URLList::slotStart(QNetworkOperation *qno) {
	connected = true;
}
void
URLList::slotFinished(QNetworkOperation *qno) {
	connected = false;
	if (qno->state() == QNetworkProtocol::StFailed) {
/*		switch(qno->errorCode()) {
		case QNetworkProtocol::NoError:
			cerr << "No error occurred" << endl;
			break;
 		case QNetworkProtocol::ErrValid:
			cerr << "The URL you are operating on is not valid" << endl;
			break;
 		case QNetworkProtocol::ErrUnknownProtocol:
			cerr << "There is no protocol implementation available for the protocol of the URL you are operating on (e.g. if the protocol is http and no http implementation has been registered)" << endl;
			break; 
		case QNetworkProtocol::ErrUnsupported:
			cerr << "The operation is not supported by the protocol" << endl;
			break;
		case QNetworkProtocol::ErrParse:
			cerr << "Parse error of the URL" << endl;
			break;
		case QNetworkProtocol::ErrLoginIncorrect:
			cerr << "You needed to login but the username and or password are wrong" << endl;
			break;
		case QNetworkProtocol::ErrHostNotFound:
			cerr << "The specified host (in the URL) couldn?t be found" << endl;
			break;
		case QNetworkProtocol::ErrListChlidren:
			cerr << "An error occurred while listing the children" << endl;
			break; 
		case QNetworkProtocol::ErrMkdir:
			cerr << "An error occurred when creating a directory" << endl;
			break;
		case QNetworkProtocol::ErrRemove:
			cerr << "An error occurred while removing a child" << endl;
			break;
		case QNetworkProtocol::ErrRename:
			cerr << "An error occurred while renaming a child" << endl;
			break;
		case QNetworkProtocol::ErrGet:
			cerr << "An error occurred while getting (retrieving) data" << endl;
			break;
		case QNetworkProtocol::ErrPut:
			cerr << "An error occurred while putting (uploading) data" << endl;
			break; 
		case QNetworkProtocol::ErrFileNotExisting:
			cerr << "A file which is needed by the operation doesn't exist" << endl;
			break; 
		case QNetworkProtocol::ErrPermissionDenied:
			cerr << "The permission for doing the operation has been denied" << endl;
			break;
		} */
	} else {
		if (!queue.isEmpty()) {
			current = *queue.dequeue();
			op.setPath(current);
			cout << current << "/" << endl;
			timer->start(maxtime, TRUE);
			op.listChildren();
		} else {
			QApplication::exit(0);
		}
	}
}
void
URLList::timeout() {
	if (!connected) {
		QApplication::exit(0);
	}
}
