#! /usr/bin/perl
use strict;

my %names;
my %groups;

if ($ARGV[0]) {
	getIPname($ARGV[0], \%names, \%groups);
} else {
	my $i;
	for ($i=220; $i<243; $i++) {
		foreach (`nmap -sP -T5 137.224.$i.11-250`) {
			if (m/\d\d?\d?\.\d\d?\d?\.(\d\d?\d?)\.(\d\d?\d?)/) {
		                my $ip = "137.224.$1.$2";
				getIPname($ip, \%names, \%groups);
			}
		}
	}
}

my @oldnames = `cat /var/www/crawler/smbdata/computernames`;
foreach (@oldnames) {
	chomp;
	my ($ip, $name, $group) = split("\t");
	if (!$names{$ip}) {
		$names{$ip} = $name;
	}
	if (!$groups{$ip}) {
		$groups{$ip} = $name;
	}
}
open(FH, "> /var/www/crawler/smbdata/computernames");
foreach (keys(%names)) {
	print FH $_."\t".$names{$_}."\t".$groups{$_}."\n";
}
close(FH);

sub getIPname {
        my $ip = $_[0];
	my $names = $_[1];
	my $groups = $_[2];

        # get the name of the host
        my @lines1 = `nmblookup -A $ip`;
        my $name;
        my $group;
        foreach (@lines1) {
		if (m/^[\t ]+([^\t]+[^ \t])[ \t]+<00> - <GROUP>/) {
			$group = $1;
		} elsif (m/^[\t ]+([^\t]+[^ \t])[ \t]+<00> - /) {
			$name = $1;
		}
	}
	chomp $group;
	$names->{$ip} = $name;
	$groups->{$ip} = $group;
}

